<?php if (! defined('ABSPATH')) exit; // Exit if accessed directly
class SH4_Employees_Html_Admin_View_Settings
{
	public function __construct(
		HC3_Hooks $hooks,
		HC3_Ui $ui,
		HC3_Ui_Layout1 $layout,
		HC3_Post $post,
		HC3_Settings $settings
	)
	{
		$this->ui = $ui;
		$this->layout = $layout;
		$this->self = $hooks->wrap($this);
		$this->post = $hooks->wrap($post);
		$this->settings = $hooks->wrap($settings);
	}

	public function get()
	{
		$form = $this->ui->makeForm(
			'admin/employees/settings',
			$this->self->form()
			);

		$this->layout
			->setContent( $form )
			->setBreadcrumb( $this->self->breadcrumb() )
			->setHeader( $this->self->header() )
			;

		$out = $this->layout->render();
		return $out;
	}

	public function post()
	{
		$take = array( 'shifts_show_employee_user' );

		foreach( $take as $k ){
			$this->settings->set( $k, $this->post->get($k) );
		}

		$return = array( 'admin/employees/settings', '__Settings Updated__' );
		return $return;
	}

	public function breadcrumb()
	{
		$return = array();
		$return['admin'] = array( 'admin', '__Administration__' );
		$return['admin/employees'] = array( 'admin/employees', '__Employees__' );
		return $return;
	}

	public function menu()
	{
		$return = array();
		return $return;
	}

	public function header()
	{
		$out = '__Settings__';
		return $out;
	}

	public function form()
	{
		$values = array();
		$pnames = array( 'shifts_show_employee_user' );
		foreach( $pnames as $pname ){
			$values[$pname] = $this->settings->get($pname);
		}

		$inputs = $this->ui->makeList()
			->add( $this->ui->makeInputCheckbox( 'shifts_show_employee_user', '__Show Employee Username In Schedule__', 1, $values['shifts_show_employee_user'] ) )
			;

		$buttons = $this->ui->makeInputSubmit( '__Save__')
			->tag('primary')
			;

		$out = $this->ui->makeList()
			->add( $inputs )
			->add( $buttons )
			;

		return $out;
	}
}